#!/usr/bin/env perl
use strict;
use warnings;
use List::Util qw/min/;

sub edit_distance {
    my ($s1, $s2) = @_;
    my @LD;
    my @s1 = split //, $s1;
    my @s2 = split //, $s2;

    for (my $i = 0; $i <= @s1; $i++) {
        $LD[$i][0] = $i;
    }

    for (my $j = 0; $j <= @s2; $j++) {
        $LD[0][$j] = $j;
    }

    for (my $i = 1; $i <= @s1; $i++) {
        for (my $j = 1; $j <= @s2; $j++) {
            my $diff = ($s1[$i - 1] eq $s2[$j - 1]) ? 0 : 1;
            $LD[$i][$j] = min(
                $LD[$i - 1][$j - 1] + $diff,
                $LD[$i - 1][$j] + 1,
                $LD[$i][$j - 1] + 1,
            );
        }
    }

    return $LD[-1][-1];
}

use Test::More qw/no_plan/;
use utf8;

is edit_distance('伊藤直也', '伊藤直也'), 0;
is edit_distance('伊藤直也', '伊藤直哉'), 1;
is edit_distance('伊藤直也', '伊藤直'),   1;
is edit_distance('伊藤直也', '佐藤直人'), 2;
is edit_distance('伊藤直也', '佐藤B作'),  3;
