#!/usr/bin/env perl
use strict;
use warnings;

sub ngram {
    my ($str, $n) = @_;
    $n ||= 2;
    my $len = length $str;

    if ($len < $n) {
        return $str;
    }

    my @ngrams;
    for my $i (0..$len - $n) {
        push @ngrams, substr($str, $i, $n);
    }
    return @ngrams;

    ## yet another version
    # return map { substr($str, $_, $n) } 0..$len - $n;
}

use Test::More qw/no_plan/;
use utf8;

is_deeply [ngram('hello', 2)],    [qw/he el ll lo/];
is_deeply [ngram('hail',  2)],    [qw/ha ai il/];
is_deeply [ngram('perl6', 2)],    [qw/pe er rl l6/];
is_deeply [ngram('aa', 2)],       [qw/aa/];
is_deeply [ngram('a', 2)],        [qw/a/];
is_deeply [ngram('伊藤直也', 2)], [qw/伊藤 藤直 直也/]
